SystemOrganization addCategory: #'ToolBuilder-Morphic'!

SimpleHierarchicalListMorph subclass: #PluggableTreeMorph
	instanceVariableNames: 'roots selectedWrapper getRootsSelector getChildrenSelector hasChildrenSelector getLabelSelector getIconSelector getSelectedPathSelector setSelectedSelector getHelpSelector dropItemSelector wantsDropSelector dragItemSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeMorph commentStamp: 'ar 2/12/2005 04:38' prior: 0!
A pluggable tree morph.!

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 14:58'!
acceptDroppingMorph: aMorph event: evt
	| item dropTarget |
	dropItemSelector ifNil:[^self].
	item := aMorph passenger.
	dropTarget := (self itemFromPoint: evt position) withoutListWrapper.
	model perform: dropItemSelector with: item with: dropTarget.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:19'!
balloonTextForNode: node
	getHelpSelector ifNil:[^nil].
	^model perform: getHelpSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 01:13'!
contentsOfNode: node
	| children |
	getChildrenSelector ifNil:[^#()].
	children := model perform: getChildrenSelector with: node item.
	^children collect:[:item| PluggableTreeItemNode with: item model: self]! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector
	^dragItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/11/2007 13:53'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
dropItemSelector
	^dropItemSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'mvdg 2/9/2007 21:37'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
dropNode: srcNode on: dstNode
	dropItemSelector ifNil:[^nil].
	model perform: dropItemSelector with: srcNode item with: dstNode item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector
	^getHelpSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
getHelpSelector: aSymbol
	getHelpSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector
	^getIconSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getIconSelector: aSymbol
	getIconSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector
	^getLabelSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:57'!
getMenuSelector
	^getMenuSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:57'!
getMenuSelector: aSymbol
	getMenuSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector
	^getRootsSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
getRootsSelector: aSelector
	getRootsSelector := aSelector.
	self update: getRootsSelector.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector
	^getSelectedPathSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 03:33'!
getSelectedPathSelector: aSymbol
	getSelectedPathSelector := aSymbol.! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:24'!
hasChildrenSelector
	^hasChildrenSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:25'!
hasChildrenSelector: aSymbol
	hasChildrenSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:11'!
hasNodeContents: node
	hasChildrenSelector ifNil:[^node contents isEmpty not].
	^model perform: hasChildrenSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
iconOfNode: node
	getIconSelector ifNil:[^nil].
	^model perform: getIconSelector with: node item! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:02'!
isDraggableNode: node
	^true! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector
	^keystrokeActionSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:58'!
keystrokeActionSelector: aSymbol
	keystrokeActionSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 2/12/2005 00:20'!
printNode: node
	getLabelSelector ifNil:[^node item printString].
	^model perform: getLabelSelector with: node item! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:22'!
roots
	^roots! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 01:11'!
roots: anArray
	roots := anArray collect:[:item| PluggableTreeItemNode with: item model: self].
	self list: roots.! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 17:29'!
selectPath: path in: listItem
	path isEmpty ifTrue: [^self setSelectedMorph: nil].
	listItem withSiblingsDo: [:each | 
		(each complexContents item = path first) ifTrue: [
			each isExpanded ifFalse: [
				each toggleExpandedState.
				self adjustSubmorphPositions.
			].
			each changed.
			path size = 1 ifTrue: [
				^self setSelectedMorph: each
			].
			each firstChild ifNil: [^self setSelectedMorph: nil].
			^self selectPath: path allButFirst in: each firstChild
		].
	].
	^self setSelectedMorph: nil

! !

!PluggableTreeMorph methodsFor: 'selection' stamp: 'ar 2/12/2005 01:20'!
setSelectedMorph: aMorph
	selectedWrapper := aMorph complexContents.
	self selection: selectedWrapper.
	setSelectedSelector ifNotNil:[
		model 
			perform: setSelectedSelector 
			with: (selectedWrapper ifNotNil:[selectedWrapper item]).
	].! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
setSelectedSelector
	^setSelectedSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
setSelectedSelector: aSymbol
	setSelectedSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 15:08'!
startDrag: evt 
	| ddm itemMorph passenger |
	self dragEnabled
		ifTrue: [itemMorph := scroller submorphs
						detect: [:any | any highlightedForMouseDown]
						ifNone: []].
	(itemMorph isNil
			or: [evt hand hasSubmorphs])
		ifTrue: [^ self].
	itemMorph highlightForMouseDown: false.
	itemMorph ~= self selectedMorph
		ifTrue: [self setSelectedMorph: itemMorph].
	passenger := self model perform: dragItemSelector with: itemMorph withoutListWrapper.
	passenger
		ifNotNil: [ddm := TransferMorph withPassenger: passenger from: self.
			ddm dragTransferType: #dragTransferPlus.
			Preferences dragNDropWithAnimation
				ifTrue: [self model dragAnimationFor: itemMorph transferMorph: ddm].
			evt hand grabMorph: ddm].
	evt hand releaseMouseFocus: self! !

!PluggableTreeMorph methodsFor: 'updating' stamp: 'ar 2/12/2005 19:11'!
update: what
	what ifNil:[^self].
	what == getRootsSelector ifTrue:[
		self roots: (model perform: getRootsSelector)
	].
	what == getSelectedPathSelector ifTrue:[
		^self selectPath: (model perform: getSelectedPathSelector)
			in: (scroller submorphs at: 1 ifAbsent: [^self]) 
	].
	^super update: what! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:26'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableTreeMorph methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:27'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableTreeMorph methodsFor: 'morphic' stamp: 'mvdg 2/14/2007 14:35'!
wantsDroppedMorph: aMorph event: anEvent
	aMorph dragTransferType == #dragTransferPlus ifFalse:[^false].
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^ (model perform: wantsDropSelector with: aMorph passenger) == true.! !

!PluggableTreeMorph methodsFor: 'node access' stamp: 'ar 7/15/2005 12:11'!
wantsDroppedNode: srcNode on: dstNode
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^(model perform: wantsDropSelector with: srcNode with: dstNode) == true! !

ToolBuilder subclass: #MorphicToolBuilder
	instanceVariableNames: 'widgets panes parentMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicToolBuilder commentStamp: 'ar 2/11/2005 15:02' prior: 0!
The Morphic tool builder.!

!MorphicToolBuilder class methodsFor: 'accessing' stamp: 'ar 2/11/2005 15:24'!
isActiveBuilder
	"Answer whether I am the currently active builder"
	^Smalltalk isMorphic! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/17/2005 00:00'!
add: aMorph to: aParent
	aParent addMorphBack: aMorph.
	aParent isSystemWindow ifTrue:[
		aParent addPaneMorph: aMorph.
	].! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'cmm 3/2/2010 17:19'!
alternateMultiSelectListClass
	^ AlternatePluggableListMorphOfMany ! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'stephaneducasse 2/3/2006 22:35'!
asFrame: aRectangle
	| frame |
	aRectangle ifNil:[^nil].
	frame := LayoutFrame new.
	frame 
		leftFraction: aRectangle left; 
		rightFraction: aRectangle right; 
		topFraction: aRectangle top; 
		bottomFraction: aRectangle bottom.
	^frame! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'btr 11/26/2006 12:49'!
buildHelpFor: widget spec: aSpec
	aSpec help
		ifNotNil: [widget setBalloonText: aSpec help]! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 8/7/2009 19:40'!
buildPluggableActionButton: aSpec
	| button |
	button := self buildPluggableButton: aSpec.
	button color: Color white.
	^button! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'cmm 2/19/2010 15:06'!
buildPluggableAlternateMultiSelectionList: aSpec
	| listMorph listClass |
	aSpec getSelected ifNotNil: [ ^ self error: 'There is no PluggableAlternateListMorphOfManyByItem' ].
	listClass := self alternateMultiSelectListClass.
	listMorph := listClass 
		on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	listMorph
		setProperty: #highlightSelector toValue: #highlightMessageList:with: ;
		setProperty: #itemConversionMethod toValue: #asStringOrText ;
		setProperty: #balloonTextSelectorForSubMorphs toValue: #balloonTextForClassAndMethodString ;
		enableDragNDrop: Preferences browseWithDragNDrop ;
		menuTitleSelector: #messageListSelectorTitle.
	self 
		register: listMorph
		id: aSpec name.
	listMorph
		keystrokeActionSelector: aSpec keyPress ;
		getListElementSelector: aSpec listItem ;
		getListSizeSelector: aSpec listSize.
	self 
		buildHelpFor: listMorph 
		spec: aSpec. 
	self 
		setFrame: aSpec frame 
		in: listMorph.
	parent ifNotNil: [ self add: listMorph to: parent ].
	panes ifNotNil: [ aSpec list ifNotNil:[panes add: aSpec list ] ].
	^ listMorph! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'dtl 9/24/2011 10:16'!
buildPluggableButton: aSpec
	| widget label state action enabled |
	label := aSpec label.
	state := aSpec state.
	action := aSpec action.
	widget := self buttonClass on: aSpec model
				getState: (state isSymbol ifTrue:[state])
				action: nil
				label: (label isSymbol ifTrue:[label]).
	widget style: aSpec style.
	aSpec changeLabelWhen
		ifNotNilDo: [ :event | widget whenChanged: event update: aSpec label].
	self register: widget id: aSpec name.
	enabled := aSpec enabled.
	enabled isSymbol
		ifTrue:[widget getEnabledSelector: enabled]
		ifFalse:[widget enabled:enabled].
	widget action: action.
	widget getColorSelector: aSpec color.
	widget offColor: Color white..
	self buildHelpFor: widget spec: aSpec. 
	(label isSymbol or:[label == nil]) ifFalse:[widget label: label].
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'rww 9/11/2010 04:23'!
buildPluggableCheckBox: spec

	| widget label state action |
	label := spec label.
	state := spec state.
	action := spec action.
	widget := self checkBoxClass on: spec model
				getState: (state isSymbol ifTrue:[state])
				action: (action isSymbol ifTrue:[action])
				label: (label isSymbol ifTrue:[label]).
	self register: widget id: spec name.

	widget installButton.
"	widget getColorSelector: spec color.
	widget offColor: Color white..
	self buildHelpFor: widget spec: spec. 
	(label isSymbol or:[label == nil]) ifFalse:[widget label: label].
"	self setFrame: spec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'Igor.Stasenko 1/17/2010 04:12'!
buildPluggableCodePane: aSpec
	"Install the default styler for code panes.
	Implementation note: We should just be doing something like, e.g.,
		^(self buildPluggableText: aSpec) useDefaultStyler
	Unfortunately, this will retrieve and layout the initial text twice which
	can make for a noticable performance difference when looking at some
	larger piece of code. So instead we copy the implementation from 
	buildPlugggableText: here and insert #useDefaultStyler at the right point"
	| widget |
	widget := self codePaneClass new.
	widget useDefaultStyler.
	widget on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget font: Preferences standardCodeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'rww 9/11/2010 14:15'!
buildPluggableDropDownList: spec

	| widget model listSelector selectionSelector selectionSetter |
	model := spec model.
	listSelector := spec listSelector.
	selectionSelector := spec selectionSelector.
	selectionSetter := spec selectionSetter.
	widget := self dropDownListClass new
		model: model;
		listSelector: listSelector;
		selectionSelector: selectionSelector;
		selectionSetter: selectionSetter;
		yourself.
	self register: widget id: spec name.

	widget installDropDownList.
	self setFrame: spec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'md 8/15/2005 17:55'!
buildPluggableInputField: aSpec
	| widget |
	widget := self buildPluggableText: aSpec.
	widget acceptOnCR: true.
	widget hideScrollBarsIndefinitely.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'cwp 12/8/2011 12:02'!
buildPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := self listClass.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	widget getIconSelector: aSpec icon.
	widget doubleClickSelector: aSpec doubleClick.
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget autoDeselect: aSpec autoDeselect.
	widget keystrokePreviewSelector: aSpec keystrokePreview.
	aSpec color isNil ifFalse: [widget color: aSpec color].
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'building' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
buildPluggableMenu: menuSpec 
	| prior menu |
	prior := parentMenu.
	parentMenu := menu := self menuClass new.
	menuSpec label ifNotNil:[parentMenu addTitle: menuSpec label].
	menuSpec items do:[:each| each buildWith: self].
	parentMenu := prior.
	^menu! !

!MorphicToolBuilder methodsFor: 'building' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
buildPluggableMenuItem: itemSpec
	| item action label menu |
	item := self menuItemClass new.
	label := itemSpec label.
	itemSpec checked ifTrue:[label := '<on>', label] ifFalse:[label := '<off>', label].
	item contents: label.
	item isEnabled: itemSpec enabled.
	(action := itemSpec action) ifNotNil:[
		item 
			target: action receiver;
			selector: action selector;
			arguments: action arguments.
	].
	(menu := itemSpec subMenu) ifNotNil:[
		item subMenu: (menu buildWith: self).
	].
	parentMenu ifNotNil:[parentMenu addMorphBack: item].
	itemSpec separator ifTrue:[parentMenu addLine].
	^item! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableMultiSelectionList: aSpec
	| widget listClass |
	aSpec getSelected ifNotNil:[^self error:'There is no PluggableListMorphOfManyByItem'].
	listClass := self multiSelectListClass.
	widget := listClass on: aSpec model
		list: aSpec list
		primarySelection: aSpec getIndex
		changePrimarySelection: aSpec setIndex
		listSelection: aSpec getSelectionList
		changeListSelection: aSpec setSelectionList
		menu: aSpec menu.
	self register: widget id: aSpec name.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggablePanel: aSpec
	| widget children frame |
	widget := self panelClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget color: Color transparent.
	widget clipSubmorphs: true.
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	self setLayout: aSpec layout in: widget.
	widget layoutInset: 0.
	widget borderWidth: 0.
	widget submorphsDo:[:sm|
		(frame := sm layoutFrame) ifNotNil:[
			(frame rightFraction = 0 or:[frame rightFraction = 1]) 
				ifFalse:[frame rightOffset:1].
			(frame bottomFraction = 0 or:[frame bottomFraction = 1]) 
				ifFalse:[frame bottomOffset: 1]]].
	widget color: Color transparent.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableText: aSpec
	| widget |
	widget := self textPaneClass on: aSpec model
				text: aSpec getText 
				accept: aSpec setText
				readSelection: aSpec selection 
				menu: aSpec menu.
	widget askBeforeDiscardingEdits: aSpec askBeforeDiscardingEdits.
	widget font: Preferences standardCodeFont.
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec. 
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
	widget borderColor: Color lightGray.
	widget color: Color white.
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'ar 1/23/2010 14:33'!
buildPluggableTree: aSpec
	| widget |
	widget := self treeClass new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	widget getSelectedPathSelector: aSpec getSelectedPath.
	widget setSelectedSelector: aSpec setSelected.
	widget getChildrenSelector: aSpec getChildren.
	widget hasChildrenSelector: aSpec hasChildren.
	widget getLabelSelector: aSpec label.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec help.
	widget getMenuSelector: aSpec menu.
	widget keystrokeActionSelector: aSpec keyPress.
	widget getRootsSelector: aSpec roots.
	widget autoDeselect: aSpec autoDeselect.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget dragItemSelector: aSpec dragItem.
	self setFrame: aSpec frame in: widget.
	parent ifNotNil:[self add: widget to: parent].
"	panes ifNotNil:[
		aSpec roots ifNotNil:[panes add: aSpec roots].
	].	"
	^widget! !

!MorphicToolBuilder methodsFor: 'pluggable widgets' stamp: 'mtf 2/4/2011 14:33'!
buildPluggableWindow: aSpec
	| widget children |
	aSpec layout == #proportional ifFalse:[
		"This needs to be implemented - probably by adding a single pane and then the rest"
		^self error: 'Not implemented'.
	].
	widget := (self windowClassFor: aSpec) new.
	self register: widget id: aSpec name.
	widget model: aSpec model.
	aSpec label ifNotNil:
		[:label|
		label isSymbol 
			ifTrue:[widget getLabelSelector: label]
			ifFalse:[widget setLabel: label]].
	aSpec multiWindowStyle notNil ifTrue:
		[widget savedMultiWindowState: (SavedMultiWindowState on: aSpec model)].
	children := aSpec children.
	children isSymbol ifTrue:[
		widget getChildrenSelector: children.
		widget update: children.
		children := #().
	].
	widget closeWindowSelector: aSpec closeAction.
	panes := OrderedCollection new.
	self buildAll: children in: widget.
	self buildHelpFor: widget spec: aSpec. 
	widget bounds: (RealEstateAgent 
		initialFrameFor: widget 
		initialExtent: (aSpec extent ifNil:[widget initialExtent])
		world: self currentWorld).
	widget setUpdatablePanesFrom: panes.
	^widget! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:01'!
buttonClass
	^ PluggableButtonMorphPlus! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'rww 9/11/2010 03:39'!
checkBoxClass
	^ PluggableCheckBoxMorph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
close: aWidget
	"Close a previously opened widget"
	aWidget delete! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:03'!
codePaneClass
	^ PluggableTextMorphPlus! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'rww 9/11/2010 14:05'!
dropDownListClass
	^ PluggableDropDownListMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:11'!
listByItemClass
	^ PluggableListMorphByItemPlus! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:06'!
listClass
	^ PluggableListMorphPlus! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuClass
	^ MenuMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:20'!
menuItemClass
	^ MenuItemMorph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
multiSelectListClass
	^ PluggableListMorphOfMany! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 10/4/2009 22:47'!
open: anObject
	"Build and open the object. Answer the widget opened."
	| morph |
	anObject isMorph 
		ifTrue:[morph := anObject]
		ifFalse:[morph := self build: anObject].
	(morph isKindOf: MenuMorph)
		ifTrue:[morph popUpInWorld: World].
	(morph isKindOf: SystemWindow)
		ifTrue:[morph openInWorldExtent: morph extent]
		ifFalse:[morph openInWorld].
	^morph! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:40'!
open: anObject label: aString
	"Build an open the object, labeling it appropriately.  Answer the widget opened."
	| window |
	window := self open: anObject.
	window setLabel: aString.
	^window! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:14'!
panelClass
	^ PluggablePanelMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/6/2009 16:14'!
register: widget id: id
	id ifNil:[^self].
	widgets ifNil:[widgets := Dictionary new].
	widgets at: id put: widget.
	widget setNameTo: id.! !

!MorphicToolBuilder methodsFor: 'opening' stamp: 'ar 6/5/2005 12:41'!
runModal: aWidget
	"Run the (previously opened) widget modally, e.g., 
	do not return control to the sender before the user has responded."
	[aWidget world notNil] whileTrue: [
		aWidget outermostWorldMorph doOneCycle.
	].
! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'dc 1/10/2008 14:17'!
setFrame: aRectangle in: widget
	| frame |
	aRectangle ifNil:[^nil].
	frame := aRectangle isRectangle
		ifTrue: [self asFrame: aRectangle]
		ifFalse: [aRectangle]. "assume LayoutFrame"
	widget layoutFrame: frame.
	widget hResizing: #spaceFill; vResizing: #spaceFill.
	(parent isSystemWindow) ifTrue:[
		widget borderWidth: 2; borderColor: #inset.
	].! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 9/16/2009 23:11'!
setLayout: layout in: widget
	layout == #proportional ifTrue:[
		widget layoutPolicy: ProportionalLayout new.
		^self].
	layout == #horizontal ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #leftToRight.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	layout == #vertical ifTrue:[
		widget layoutPolicy: TableLayout new.
		widget listDirection: #topToBottom.
		widget submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
		widget cellInset: 1@1.
		widget layoutInset: 1@1.
		widget color: Color transparent.
		"and then some..."
		^self].
	^self error: 'Unknown layout: ', layout.! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:15'!
textPaneClass
	^ PluggableTextMorphPlus! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
treeClass
	^ PluggableTreeMorph! !

!MorphicToolBuilder methodsFor: 'private' stamp: 'ar 7/14/2005 22:30'!
widgetAt: id ifAbsent: aBlock
	widgets ifNil:[^aBlock value].
	^widgets at: id ifAbsent: aBlock! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'Igor.Stasenko 1/17/2010 04:16'!
windowClass
	^ PluggableSystemWindow! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'mtf 2/4/2011 14:32'!
windowClassFor: aSpec
	aSpec isDialog ifTrue: [^ PluggableDialogWindow].
	^aSpec multiWindowStyle
		caseOf:
		{	[nil]				->	[PluggableSystemWindow].
			[#labelButton]	->	[PluggableSystemWindowWithLabelButton] }
		otherwise:				[PluggableSystemWindowWithLabelButton]! !

AlignmentMorph subclass: #PluggableCheckBoxMorph
	instanceVariableNames: 'model actionSelector valueSelector label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableCheckBoxMorph class methodsFor: 'as yet unclassified' stamp: 'rww 9/11/2010 03:44'!
on: anObject getState: getStateSel action: actionSel label: labelSel

	^ self new
		on: anObject
		getState: getStateSel
		action: actionSel
		label: labelSel
		menu: nil
! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
actionSelector
	"Answer the value of actionSelector"

	^ actionSelector! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
actionSelector: anObject
	"Set the value of actionSelector"

	actionSelector := anObject! !

!PluggableCheckBoxMorph methodsFor: 'installing' stamp: 'rww 9/11/2010 04:10'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 0;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		yourself! !

!PluggableCheckBoxMorph methodsFor: 'installing' stamp: 'rww 9/11/2010 04:10'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PluggableCheckBoxMorph methodsFor: 'installing' stamp: 'rww 9/11/2010 03:36'!
installButton

	| aButton aLabel |
	aButton := UpdatingThreePhaseButtonMorph checkBox
		target: self model;
		actionSelector: self actionSelector;
		getSelector: self valueSelector;
		yourself.
	aLabel := (StringMorph contents: self label translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).
	self addMorph: (self horizontalPanel
		addMorphBack: aButton;
		addMorphBack: aLabel;
		yourself).! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
label
	"Answer the value of label"

	^ label! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
label: anObject
	"Set the value of label"

	label := anObject! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:38'!
model
	"Answer the value of model"

	^ model.
! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
model: anObject
	"Set the value of model"

	model := anObject! !

!PluggableCheckBoxMorph methodsFor: 'initialization' stamp: 'rww 9/11/2010 03:45'!
on: anObject getState: getStateSel action: actionSel label: labelSel menu: menuSel

	self model: anObject.
	self valueSelector: getStateSel.
	self actionSelector: actionSel.
	self label: (self model perform: labelSel).
! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
valueSelector
	"Answer the value of valueSelector"

	^ valueSelector! !

!PluggableCheckBoxMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 03:37'!
valueSelector: anObject
	"Set the value of valueSelector"

	valueSelector := anObject! !

AlignmentMorph subclass: #PluggableDropDownListMorph
	instanceVariableNames: 'model listSelector selectionSelector selectionSetter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableDropDownListMorph methodsFor: 'drawing' stamp: 'rww 9/11/2010 14:22'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 0;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		yourself! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:34'!
currentSelection

	^ self model perform: selectionSelector! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:34'!
currentSelection: obj

	^ self model perform: selectionSetter with: obj! !

!PluggableDropDownListMorph methodsFor: 'drawing' stamp: 'rww 9/11/2010 14:22'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PluggableDropDownListMorph methodsFor: 'drawing' stamp: 'rww 9/11/2010 14:20'!
installDropDownList

	| aButton aLabel |
	aButton := PluggableButtonMorph on: self model getState: nil action: nil.
	aLabel := (StringMorph contents: self model currentRemoteVatId translated
				font: (StrikeFont familyName: TextStyle defaultFont familyName
							size: TextStyle defaultFont pointSize - 1)).
	self addMorph: (self horizontalPanel
		addMorphBack: aLabel;
		addMorphBack: aButton;
		yourself).! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:33'!
list
	"Answer the value of list"

	^ self model perform: self listSelector.
	! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
listSelector
	"Answer the value of listSelector"

	^ listSelector! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
listSelector: anObject
	"Set the value of listSelector"

	listSelector := anObject! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:33'!
model
	^ model! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
model: anObject
	"Set the value of model"

	model := anObject! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
selectionSelector
	"Answer the value of selectionSelector"

	^ selectionSelector! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
selectionSelector: anObject
	"Set the value of selectionSelector"

	selectionSelector := anObject! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
selectionSetter
	"Answer the value of selectionSetter"

	^ selectionSetter! !

!PluggableDropDownListMorph methodsFor: 'accessing' stamp: 'rww 9/11/2010 13:32'!
selectionSetter: anObject
	"Set the value of selectionSetter"

	selectionSetter := anObject! !

AlignmentMorph subclass: #PluggablePanelMorph
	instanceVariableNames: 'model getChildrenSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggablePanelMorph commentStamp: 'ar 2/11/2005 20:13' prior: 0!
A pluggable panel morph which deals with changing children.!

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector
	^getChildrenSelector! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:47'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol.! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model
	^model! !

!PluggablePanelMorph methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:48'!
model: aModel
	model ifNotNil:[model removeDependent: self].
	model := aModel.
	model ifNotNil:[model addDependent: self].! !

!PluggablePanelMorph methodsFor: 'update' stamp: 'ar 2/11/2005 20:01'!
update: what
	what == nil ifTrue:[^self].
	what == getChildrenSelector ifTrue:[
		self removeAllMorphs.
		self addAllMorphs: (model perform: getChildrenSelector).
		self submorphsDo:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].! !

PluggableListMorph subclass: #PluggableListMorphPlus
	instanceVariableNames: 'dragItemSelector dropItemSelector wantsDropSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableListMorphPlus commentStamp: 'ar 7/15/2005 11:10' prior: 0!
Extensions for PluggableListMorph needed by ToolBuilder!

PluggableListMorphPlus subclass: #PluggableListMorphByItemPlus
	instanceVariableNames: 'itemList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableListMorphByItemPlus commentStamp: '<historical>' prior: 0!
Main comment stating the purpose of this class and relevant relationship to other classes.

Possible useful expressions for doIt or printIt.

Structure:
 instVar1		type -- comment about the purpose of instVar1
 instVar2		type -- comment about the purpose of instVar2

Any further useful comments about the general approach of this implementation.!

!PluggableListMorphByItemPlus methodsFor: 'model access' stamp: 'stephaneducasse 2/3/2006 22:35'!
changeModelSelection: anInteger
	"Change the model's selected item to be the one at the given index."

	| item |
	setIndexSelector ifNotNil: [
		item := (anInteger = 0 ifTrue: [nil] ifFalse: [itemList at: anInteger]).
		model perform: setIndexSelector with: item].
	self update: getIndexSelector.
! !

!PluggableListMorphByItemPlus methodsFor: 'model access' stamp: 'jrd 12/8/2008 23:24'!
getCurrentSelectionIndex
	"Answer the index of the current selection."
	| item |
	getIndexSelector == nil ifTrue: [^ 0].
	item := model perform: getIndexSelector.
	^ itemList findFirst: [ :x | x = item]
! !

!PluggableListMorphByItemPlus methodsFor: 'as yet unclassified' stamp: 'ar 7/15/2005 11:23'!
getList
	"cache the raw items in itemList"
	itemList := getListSelector ifNil: [ #() ] ifNotNil: [ model perform: getListSelector ].
	^super getList! !

!PluggableListMorphByItemPlus methodsFor: 'initialization' stamp: 'stephaneducasse 2/3/2006 22:35'!
list: arrayOfStrings
	"Set the receivers items to be the given list of strings."
	"Note: the instance variable 'items' holds the original list.
	 The instance variable 'list' is a paragraph constructed from
	 this list."
"NOTE: this is no longer true; list is a real list, and itemList is no longer used.  And this method shouldn't be called, incidentally."
self isThisEverCalled .
	itemList := arrayOfStrings.
	^ super list: arrayOfStrings! !

!PluggableListMorphPlus methodsFor: 'drag and drop' stamp: 'ar 7/15/2005 11:28'!
acceptDroppingMorph: aMorph event: evt
	| item |
	dropItemSelector ifNil:[^self].
	item := aMorph passenger.
	model perform: dropItemSelector with: item with: potentialDropRow.
	self resetPotentialDropRow.
	evt hand releaseMouseFocus: self.
	Cursor normal show.
! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 11:24'!
dragItemSelector
	^dragItemSelector! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 11:26'!
dragItemSelector: aSymbol
	dragItemSelector := aSymbol.
	aSymbol ifNotNil:[self dragEnabled: true].! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 11:25'!
dropItemSelector
	^dropItemSelector! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 11:25'!
dropItemSelector: aSymbol
	dropItemSelector := aSymbol.
	aSymbol ifNotNil:[self dropEnabled: true].! !

!PluggableListMorphPlus methodsFor: 'drag and drop' stamp: 'cmm 9/11/2011 13:01'!
startDrag: evt 
	
	dragItemSelector ifNil:[^self].
	evt hand hasSubmorphs ifTrue: [^ self].
	[ | dragIndex draggedItem ddm |
	(self dragEnabled and: [model okToChange]) ifFalse: [^ self].
	dragIndex := self rowAtLocation: evt position.
	dragIndex = 0 ifTrue:[^self].
	draggedItem := model perform: dragItemSelector with: (self modelIndexFor: dragIndex).
	draggedItem ifNil:[^self].
	ddm := TransferMorph withPassenger: draggedItem from: self.
	ddm dragTransferType: #dragTransferPlus.
	evt hand grabMorph: ddm]
		ensure: [Cursor normal show.
			evt hand releaseMouseFocus: self]! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 12:07'!
wantsDropSelector
	^wantsDropSelector! !

!PluggableListMorphPlus methodsFor: 'accessing' stamp: 'ar 7/15/2005 12:07'!
wantsDropSelector: aSymbol
	wantsDropSelector := aSymbol! !

!PluggableListMorphPlus methodsFor: 'drag and drop' stamp: 'ar 7/15/2005 12:08'!
wantsDroppedMorph: aMorph event: anEvent
	aMorph dragTransferType == #dragTransferPlus ifFalse:[^false].
	dropItemSelector ifNil:[^false].
	wantsDropSelector ifNil:[^true].
	^(model perform: wantsDropSelector with: aMorph passenger) == true! !

ListItemWrapper subclass: #PluggableTreeItemNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTreeItemNode commentStamp: 'ar 2/12/2005 04:37' prior: 0!
Tree item for PluggableTreeMorph.!

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
acceptDroppingObject: anotherItem
	^model dropNode: anotherItem on: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
asString
	^model printNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
balloonText
	^model balloonTextForNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:02'!
canBeDragged
	^model isDraggableNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:03'!
contents
	^model contentsOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
hasContents
	^model hasNodeContents: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:04'!
icon
	^model iconOfNode: self! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 01:00'!
item
	^item! !

!PluggableTreeItemNode methodsFor: 'accessing' stamp: 'ar 2/12/2005 00:16'!
wantsDroppedObject: anotherItem
	^model wantsDroppedNode: anotherItem on: self! !

UIManager subclass: #MorphicUIManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicUIManager commentStamp: 'dtl 5/2/2010 16:07' prior: 0!
MorphicUIManager is a UIManager that implements user interface requests for a Morphic user interface.!

!MorphicUIManager class methodsFor: 'accessing' stamp: 'ar 2/11/2005 15:41'!
isActiveManager
	"Answer whether I should act as the active ui manager"
	^Smalltalk isMorphic! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ul 12/12/2010 22:00'!
chooseClassOrTrait: label from: environment
	"Let the user choose a Class or Trait. Use ListChooser in Morphic."
	
	| names index |
	names := environment classAndTraitNames.
	index := self
		chooseFrom: names
		lines: #()
		title: label.
	index = 0 ifTrue: [ ^nil ].
	^environment
		at: (names at: index)
		ifAbsent: [ nil ]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 7/16/2005 19:37'!
chooseDirectory: label from: dir
	"Let the user choose a directory"
	^FileList2 modalFolderSelector: dir! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 7/17/2005 00:28'!
chooseFileMatching: patterns label: aString
	"Let the user choose a file matching the given patterns"
	| result |
	result := FileList2 modalFileSelectorForSuffixes: patterns.
	^result ifNotNil:[result fullName]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 8/30/2009 17:01'!
chooseFont: titleString for: aModel setSelector: setSelector getSelector: getSelector
	"Open a font-chooser for the given model"
	^FontChooserTool default
		openWithWindowTitle: titleString 
		for: aModel 
		setSelector: setSelector 
		getSelector: getSelector! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'cmm 3/15/2010 18:32'!
chooseFrom: aList lines: linesArray title: aString 
	"Choose an item from the given list. Answer the index of the selected item."
	^ aList size > 30
		ifTrue:
			[ "Don't put more than 30 items in a menu.  Use ListChooser insted"
			ListChooser
				chooseFrom: aList
				title: aString ]
		ifFalse:
			[ MenuMorph
				chooseFrom: aList
				lines: linesArray
				title: aString ]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'cmm 3/15/2010 18:32'!
chooseFrom: labelList values: valueList lines: linesArray title: aString 
	"Choose an item from the given list. Answer the selected item."
	| index |
	^ labelList size > 30
		ifTrue:
			[ "No point in displaying more than 30 items in a menu.  Use ListChooser insted"
			index := ListChooser
				chooseFrom: labelList
				title: aString.
			index = 0 ifFalse: [ valueList at: index ] ]
		ifFalse:
			[ MenuMorph
				chooseFrom: labelList
				values: valueList
				lines: linesArray
				title: aString ]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 12/12/2009 00:28'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."
	^UserDialogBoxMorph confirm: queryString! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 12/12/2009 00:28'!
confirm: aString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString. Answer true if  
	the response is yes, false if no. If cancel is chosen, evaluate  
	cancelBlock. This is a modal question--the user must respond yes or no."
	^UserDialogBoxMorph confirm: aString orCancel: cancelBlock! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 1/23/2010 14:38'!
confirm: queryString trueChoice: trueChoice falseChoice: falseChoice 
	"Put up a yes/no menu with caption queryString. The actual wording for the two choices will be as provided in the trueChoice and falseChoice parameters. Answer true if the response is the true-choice, false if it's the false-choice.
	This is a modal question -- the user must respond one way or the other."
	^ UserDialogBoxMorph confirm: queryString trueChoice: trueChoice falseChoice: falseChoice ! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'cmm 5/27/2011 14:05'!
displayProgress: titleString at: aPoint from: minVal to: maxVal during: workBlock 
	"Display titleString as a caption over a progress bar while workBlock is evaluated."
	| result progress |
	progress := SystemProgressMorph
		position: aPoint
		label: titleString
		min: minVal
		max: maxVal.
	[ [ result := workBlock value: progress ]
		on: ProgressNotification
		do:
			[ : ex | ex extraParam isString ifTrue:
				[ SystemProgressMorph uniqueInstance
					labelAt: progress
					put: ex extraParam ].
			ex resume ] ] ensure: [ SystemProgressMorph close: progress ].
	^ result! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 7/22/2010 14:27'!
edit: aText label: labelString accept: anAction
	"Open an editor on the given string/text"
	| window |
	window := Workspace open.
	labelString ifNotNil: [ window setLabel: labelString ].
	"By default, don't style in UIManager edit: requests"
	window model
		shouldStyle: false;
		acceptContents:  aText;
		acceptAction: anAction.
	^window.! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 12/12/2009 00:28'!
inform: aString
	"Display a message for the user to read and then dismiss"
	^UserDialogBoxMorph inform: aString! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ul 6/18/2011 11:07'!
informUserDuring: aBlock
	"Display a message above (or below if insufficient room) the cursor 
	during execution of the given block.
		UIManager default informUserDuring:[:bar|
			#(one two three) do:[:info|
				bar value: info.
				(Delay forSeconds: 1) wait]]"
	SystemProgressMorph
		informUserAt: nil during: aBlock.! !

!MorphicUIManager methodsFor: 'initialize-release' stamp: 'dtl 2/12/2011 15:56'!
initialize
	toolBuilder := MorphicToolBuilder new! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 8/4/2009 22:17'!
multiLineRequest: queryString centerAt: aPoint initialAnswer: defaultAnswer answerHeight: answerHeight
	"Create a multi-line instance of me whose question is queryString with
	the given initial answer. Invoke it centered at the given point, and
	answer the string the user accepts.  Answer nil if the user cancels.  An
	empty string returned means that the ussr cleared the editing area and
	then hit 'accept'.  Because multiple lines are invited, we ask that the user
	use the ENTER key, or (in morphic anyway) hit the 'accept' button, to 
	submit; that way, the return key can be typed to move to the next line."
	^FillInTheBlankMorph 
		request: queryString 
		initialAnswer: defaultAnswer 
		centerAt: aPoint 
		inWorld: self currentWorld
		onCancelReturn: nil
		acceptOnCR: false! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 8/4/2009 22:15'!
request: queryString initialAnswer: defaultAnswer 
	"Create an instance of me whose question is queryString with the given 
	initial answer. Invoke it centered at the given point, and answer the 
	string the user accepts. Answer the empty string if the user cancels."
	^FillInTheBlankMorph request: queryString initialAnswer: defaultAnswer ! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'dtl 2/12/2010 19:52'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint 
	"Create an instance of me whose question is queryString with the given
	initial answer. Invoke it centered at the given point, and answer the
	string the user accepts. Answer the empty string if the user cancels."
	^FillInTheBlankMorph request: queryString initialAnswer: defaultAnswer centerAt: aPoint! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'ar 8/4/2009 22:15'!
requestPassword: queryString
	"Create an instance of me whose question is queryString. Invoke it centered
	at the cursor, and answer the string the user accepts. Answer the empty 
	string if the user cancels."
	^FillInTheBlankMorph requestPassword: queryString! !

SystemWindow subclass: #PluggableSystemWindow
	instanceVariableNames: 'getLabelSelector getChildrenSelector children closeWindowSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableSystemWindow commentStamp: 'ar 2/11/2005 20:14' prior: 0!
A pluggable system window. Fixes the issues with label retrieval and adds support for changing children.!

PluggableSystemWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'statusValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue
	^statusValue! !

!PluggableDialogWindow methodsFor: 'as yet unclassified' stamp: 'jrd 12/1/2008 23:56'!
statusValue: val
	statusValue := val! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'md 8/31/2005 07:59'!
addPaneMorph: aMorph
	self addMorph: aMorph fullFrame: aMorph layoutFrame! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector
	^closeWindowSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 9/17/2005 21:05'!
closeWindowSelector: aSymbol
	closeWindowSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'initialization' stamp: 'ar 9/17/2005 21:08'!
delete
	closeWindowSelector ifNotNil:[model perform: closeWindowSelector].
	super delete.
! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector
	^getChildrenSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getChildrenSelector: aSymbol
	getChildrenSelector := aSymbol! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:57'!
getLabelSelector
	^getLabelSelector! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:53'!
getLabelSelector: aSymbol
	getLabelSelector := aSymbol.
	self update: aSymbol.! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:52'!
label
	^label contents! !

!PluggableSystemWindow methodsFor: 'accessing' stamp: 'ar 2/13/2005 13:51'!
label: aString
	self setLabel: aString.! !

!PluggableSystemWindow methodsFor: 'updating' stamp: 'ar 2/11/2005 20:15'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue:[self setLabel: (model perform: getLabelSelector)].
	what == getChildrenSelector ifTrue:[
		children ifNil:[children := #()].
		self removeAllMorphsIn: children.
		children := model perform: getChildrenSelector.
		self addAllMorphs: children.
		children do:[:m| m hResizing: #spaceFill; vResizing: #spaceFill].
	].
	^super update: what! !

Object subclass: #ListChooser
	instanceVariableNames: 'window fullList selectedItems searchText searchMorph title listMorph index realIndex buttonBar builder addAllowed result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!ListChooser commentStamp: 'MAD 3/14/2010 16:20' prior: 0!
I am a simple dialog to allow the user to pick from a list of strings or symbols.
I support keyboard and mouse navigation, and interactive filtering of the displayed items.

You can specify whether you want the index, or the value of the selected item. If you're interested in the value, you can also allow users to Add a new value not in the list.

cmd-s or <enter> or double-click answers the currently selected item's value/index;
cmd-l or <escape> or closing the window answers nil/zero.

Now using ToolBuilder, so needs Morphic-MAD.381.

Released under the MIT Licence.!

!ListChooser class methodsFor: 'ChooserTool compatibility' stamp: 'MAD 3/14/2010 15:11'!
chooseFrom: aList
	^ self 
		chooseFrom: aList 
		title: self defaultTitle! !

!ListChooser class methodsFor: 'ChooserTool compatibility' stamp: 'MAD 3/14/2010 15:31'!
chooseFrom: aList title: aString
	^ self
		chooseIndexFrom: aList 
		title: aString
		addAllowed: false! !

!ListChooser class methodsFor: 'instance creation' stamp: 'MAD 3/14/2010 15:26'!
chooseIndexFrom: aList
	^ self 
		chooseIndexFrom: aList 
		title: self defaultTitle! !

!ListChooser class methodsFor: 'instance creation' stamp: 'cmm 3/15/2010 17:19'!
chooseIndexFrom: aList title: aString
	^ self
		chooseIndexFrom: aList 
		title: (aString isEmptyOrNil ifTrue: [ self defaultTitle ] ifFalse: [ aString ])
		addAllowed: false! !

!ListChooser class methodsFor: 'instance creation' stamp: 'cmm 3/15/2010 17:18'!
chooseIndexFrom: aList title: aString addAllowed: aBoolean
	^ self new
		chooseIndexFrom: aList 
		title: (aString isEmptyOrNil ifTrue: [ self defaultTitle ] ifFalse: [ aString ])
		addAllowed: aBoolean! !

!ListChooser class methodsFor: 'instance creation' stamp: 'MAD 3/14/2010 15:24'!
chooseItemFrom: aList
	^ self 
		chooseItemFrom: aList 
		title: self defaultTitle! !

!ListChooser class methodsFor: 'instance creation' stamp: 'MAD 3/14/2010 15:25'!
chooseItemFrom: aList title: aString
	^ self
		chooseItemFrom: aList 
		title: aString
		addAllowed: false! !

!ListChooser class methodsFor: 'instance creation' stamp: 'MAD 3/14/2010 15:25'!
chooseItemFrom: aList title: aString addAllowed: aBoolean
	^ self new
		chooseItemFrom: aList 
		title: (aString isEmptyOrNil ifTrue: [ self defaultTitle ] ifFalse: [ aString ])
		addAllowed: aBoolean! !

!ListChooser class methodsFor: 'instance creation' stamp: 'MAD 3/13/2010 18:56'!
defaultTitle
	^ 'Please choose:'! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/14/2010 15:37'!
testDictionary
	^ self 
		chooseItemFrom: (Dictionary newFrom: {#a->1. 2->#b.})
		title: 'Pick from Dictionary' "gives values, not keys"! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/14/2010 15:27'!
testIndex
	^ self 
		chooseIndexFrom: (Smalltalk classNames , Smalltalk traitNames) asOrderedCollection
		title: 'Pick a class'! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/14/2010 15:29'!
testItem
	^ self 
		chooseItemFrom: (Smalltalk classNames , Smalltalk traitNames) asOrderedCollection
		title: 'Pick a class'! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/14/2010 15:31'!
testItemAdd
	^ self 
		chooseItemFrom: (Smalltalk classNames , Smalltalk traitNames) asOrderedCollection
		title: 'Pick or Add:'
		addAllowed: true! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/15/2010 16:08'!
testLongTitle
	^ self 
		chooseItemFrom: #(this is a list of values that aren/t the point here)
		title: 'Pick from some values from this list'! !

!ListChooser class methodsFor: 'examples' stamp: 'MAD 3/14/2010 15:33'!
testSet
	^ self 
		chooseItemFrom: #(a list of values as a Set) asSet
		title: 'Pick from Set'! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/14/2010 15:58'!
accept
	"if the user submits with no valid entry, make them start over"
	self canAccept ifFalse: [ 	
		searchMorph selectAll.
		^ self ].
	
	"find the selected item in the original list, and return it"
	result := selectedItems at: index.

	builder ifNotNil: [ :bldr |
		builder := nil.
		bldr close: window ]! !

!ListChooser methodsFor: 'drawing' stamp: 'MAD 3/14/2010 16:18'!
acceptColor
	^ self canAccept 
		ifTrue: [ ColorTheme current okColor ]
		ifFalse: [ Color lightGray "ColorTheme current disabledColor <- you don't have this!!" ]! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/13/2010 18:56'!
acceptText: someText
	"the text morph wants to tell us about its contents but I don't care, I'm only interested in the list"
	self accept! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/14/2010 15:58'!
add
	"if the user submits with no valid entry, make them start over"
	self canAdd ifFalse: [ 	
		searchMorph selectAll.
		^ self ].
	
	"find the string to return"
	result := searchMorph getText.

	builder ifNotNil: [ :bldr |
		builder := nil.
		bldr close: window ]! !

!ListChooser methodsFor: 'building' stamp: 'MAD 4/3/2010 15:51'!
buildButtonBarWith: builder
	| panel button |
	panel := builder pluggablePanelSpec new
		model: self;
		layout: #proportional;
		children: OrderedCollection new.
	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Accept (s)';
		action: #accept;
		enabled: #canAccept;
		state: #canAccept;
		color: #acceptColor;
		frame: (0.0 @ 0.0 corner: 0.34@1).
	panel children add: button.

	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Add (a)';
		action: #add;
		enabled: #canAdd;
		frame: (0.36 @ 0.0 corner: 0.63@1).
	panel children add: button.

	button := builder pluggableButtonSpec new.
	button
		model: self; 
		label: 'Cancel (l)';
		action: #cancel;
		color: #cancelColor;
		frame: (0.65 @ 0.0 corner: 1@1).
	panel children add: button.
	
	^ panel! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/13/2010 21:14'!
buildListMorphWith: builder
	| listSpec |
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #list; 
		getIndex: #selectedIndex; 
		setIndex: #selectedIndex:; 
		doubleClick: #accept;
		"handleBasicKeys: false;"
		keystrokePreview: #keyStrokeFromList:;
		"doubleClickSelector: #accept;"
		autoDeselect: false.
	^ listSpec! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/14/2010 15:57'!
buildSearchMorphWith: builder
	| fieldSpec |
	fieldSpec := builder pluggableInputFieldSpec new.
	fieldSpec 
		model: self;
		getText: #searchText;
		setText: #acceptText:;
		menu: nil.
		"hideScrollBarsIndefinitely;"
		"acceptOnCR: true;"
		"setBalloonText: 'Type a string to filter down the listed items'."
		"onKeyStrokeSend: #keyStroke: to: self."
	^ fieldSpec! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/13/2010 19:02'!
buildWindowWith: builder
	| windowSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec model: self.
	windowSpec label: #title.
	windowSpec children: OrderedCollection new.
	^windowSpec! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/13/2010 19:03'!
buildWindowWith: builder specs: specs
	| windowSpec |
	windowSpec := self buildWindowWith: builder.
	specs do: [ :assoc |
		| rect action widgetSpec |
		rect := assoc key.
		action := assoc value.
		widgetSpec := action value.
		widgetSpec ifNotNil:[
			widgetSpec frame: rect.
			windowSpec children add: widgetSpec ] ].
	^ windowSpec! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/15/2010 15:56'!
buildWith: aBuilder
	| windowSpec |
	builder := aBuilder.
	windowSpec := self buildWindowWith: builder specs: {
		(0@0 corner: 1@0.05) -> [self buildSearchMorphWith: builder].
		(0@0.05 corner: 1@0.9) -> [self buildListMorphWith: builder].
		(0@0.9 corner: 1@1) -> [self buildButtonBarWith: builder].
	}.
	windowSpec closeAction: #closed.
	windowSpec extent: self initialExtent.
	window := builder build: windowSpec.
	
	
	searchMorph := window submorphs detect: 
		[ :each | each isKindOf: PluggableTextMorph ].
	searchMorph
		hideScrollBarsIndefinitely;
		acceptOnCR: true;
		setBalloonText: 'Type a string to filter down the listed items';
		onKeyStrokeSend: #keyStroke: to: self;
		hasUnacceptedEdits: true "force acceptOnCR to work even with no text entered".
	listMorph := window submorphs detect: 
		[ :each | each isKindOf: PluggableListMorph ].
	^ window! !

!ListChooser methodsFor: 'testing' stamp: 'MAD 3/13/2010 18:56'!
canAccept
	^ self selectedIndex > 0! !

!ListChooser methodsFor: 'testing' stamp: 'MAD 3/14/2010 15:05'!
canAdd
	^ addAllowed and: [ self canAccept not ]! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/13/2010 21:46'!
cancel
	"Cancel the dialog and move on"
	index := 0.
	builder ifNotNil: [ builder close: window ]! !

!ListChooser methodsFor: 'drawing' stamp: 'MAD 3/14/2010 14:55'!
cancelColor
	^ ColorTheme current cancelColor! !

!ListChooser methodsFor: 'initialize-release' stamp: 'MAD 3/14/2010 15:29'!
chooseIndexFrom: labelList title: aString
	| choice |
	choice := self chooseItemFrom: labelList title: aString addAllowed: false.
	^ fullList indexOf: choice ifAbsent: 0! !

!ListChooser methodsFor: 'initialize-release' stamp: 'cmm 3/15/2010 17:18'!
chooseIndexFrom: labelList title: aString addAllowed: aBoolean
	| choice |
	choice := self chooseItemFrom: labelList title: aString addAllowed: false.
	addAllowed := aBoolean.
	^ fullList indexOf: choice ifAbsent: 0! !

!ListChooser methodsFor: 'initialize-release' stamp: 'MAD 3/14/2010 15:34'!
chooseItemFrom: labelList title: aString addAllowed: aBoolean
	fullList := labelList asOrderedCollection. "coerce everything into an OC"
	builder := ToolBuilder default.
	self list: fullList.
	self title: aString.
	addAllowed := aBoolean.
	window := ToolBuilder default open: self.
	window center: Sensor cursorPoint.
	window setConstrainedPosition: (Sensor cursorPoint - (window fullBounds extent // 2)) hangOut: false.
	builder runModal: window.
	^ result! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/13/2010 21:46'!
closed
	"Cancel the dialog and move on"
	builder ifNotNil: [ index := 0 ]! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/13/2010 18:56'!
handlesKeyboard: evt
	^ true! !

!ListChooser methodsFor: 'building' stamp: 'MAD 3/15/2010 16:07'!
initialExtent
	| listFont titleFont buttonFont listWidth titleWidth buttonWidth |
	listFont := Preferences standardListFont.
	titleFont := Preferences windowTitleFont.
	buttonFont := Preferences standardButtonFont.
	listWidth := 20 * (listFont widthOf: $m).
	titleWidth := titleFont widthOfString: self title, '__________'. "add some space for titlebar icons"
	buttonWidth := buttonFont widthOfString: '_Accept_(s)___Add (a)___Cancel_(l)_'.
	^ (listWidth max: (titleWidth max: buttonWidth))@(30 * (listFont height))! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/14/2010 16:05'!
keyStroke: event
	| newText key |
	"handle updates to the search box interactively"
	key := event keyString.
	(key = '<up>') ifTrue: [ 
		self move: -1. 
		^ self ].
	(key = '<down>') ifTrue: [ 
		self move: 1.
		^ self ].

	(key = '<Cmd-s>') ifTrue: [ self accept. ^ self ].
	(key = '<cr>') ifTrue: [ self accept. ^ self ].

	(key = '<escape>') ifTrue: [ self cancel. ^ self ].
	(key = '<Cmd-l>') ifTrue: [ self cancel. ^ self ].
	
	(key = '<Cmd-a>') ifTrue: [ self add. ^ self ].

	"pull out what's been typed, and update the list as required"
	newText := searchMorph textMorph asText asString.
	(newText = searchText) ifFalse: [ 
		searchText := newText.
		self updateFilter ].
! !

!ListChooser methodsFor: 'event handling' stamp: 'fbs 4/3/2010 15:53'!
keyStrokeFromList: event
	"we don't want the list to be picking up events, excepting scroll events"

	"Don't sent ctrl-up/ctrl-down events to the searchMorph: they're scrolling events."
	(#(30 31) contains: [:each | each = event keyValue]) not
		ifTrue:
			["window world primaryHand keyboardFocus: searchMorph."
			searchMorph keyStroke: event.
			"let the list know we've dealt with it"
			^true].
	^false.
		! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
list
	^ selectedItems! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
list: items
	fullList := items.
	selectedItems := items.
	self changed: #itemList.! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
list: aList title: aString
	self list: aList.
	self title: aString! !

!ListChooser methodsFor: 'event handling' stamp: 'MAD 3/14/2010 15:59'!
move: offset
	| newindex |
	"The up arrow key moves the cursor, and it seems impossible to restore.
	So, for consistency, on either arrow, select everything, so a new letter-press starts over. yuk."
	searchMorph selectAll.
		
	newindex := self selectedIndex + offset.
	newindex > selectedItems size ifTrue: [ ^ nil ].
	newindex < 1 ifTrue: [ ^ nil ].
	self selectedIndex: newindex.
! !

!ListChooser methodsFor: 'drawing' stamp: 'MAD 3/13/2010 18:56'!
moveWindowNear: aPoint
	| trialRect delta |
	trialRect := Rectangle center: aPoint extent: window fullBounds extent.
	delta := trialRect amountToTranslateWithin: World bounds.
	window position: trialRect origin + delta.! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
realIndex
	^ realIndex ifNil: [ 0 ]! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
searchText
	^ searchText ifNil: [ searchText := '' ]! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
searchText: aString
	searchText := aString! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
selectedIndex
	^ index ifNil: [ index := 1 ]! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
selectedIndex: anInt
	index := (anInt min: selectedItems size).
	self changed: #selectedIndex.
	self changed: #canAccept.! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
title
	^ title ifNil: [ title := 'Please choose' ]! !

!ListChooser methodsFor: 'accessing' stamp: 'MAD 3/13/2010 18:56'!
title: aString
	title := aString.! !

!ListChooser methodsFor: 'event handling' stamp: 'ul 3/5/2011 10:52'!
updateFilter
	selectedItems := 
		searchText isEmptyOrNil 
			ifTrue: [ fullList ]
			ifFalse: [ 
				| prefixMatches otherMatches |
				prefixMatches := OrderedCollection new.
				otherMatches := OrderedCollection new.
				fullList do: [ :each | 
					| index |
					index := each findString: searchText startingAt: 1 caseSensitive: false.
					index = 1 ifTrue: [ prefixMatches add: each ].
					index > 1 ifTrue: [ otherMatches add: each ] ].
				prefixMatches
					addAllLast: otherMatches;
					yourself ].
	self changed: #list.
	self selectedIndex: 1.
	self changed: #selectedIndex.! !

PluggableTextMorph subclass: #PluggableTextMorphPlus
	instanceVariableNames: 'getColorSelector acceptAction unstyledAcceptText styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableTextMorphPlus commentStamp: 'ar 2/11/2005 21:53' prior: 0!
A pluggable text morph with support for color.!

!PluggableTextMorphPlus methodsFor: 'updating' stamp: 'ar 7/16/2005 19:02'!
accept
	super accept.
	acceptAction ifNotNil:[acceptAction value: textMorph asText].! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 7/16/2005 19:01'!
acceptAction
	^acceptAction! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 7/16/2005 19:01'!
acceptAction: anAction
	acceptAction := anAction! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/17/2009 23:48'!
acceptTextInModel 
	
	self okToStyle ifFalse:[^super acceptTextInModel].			
	"#correctFrom:to:with: is sent when the method source is
	manipulated during compilation (removing unused temps,
	changing selectors etc). But 	#correctFrom:to:with: operates 
	on the textMorph's text, and we may be saving an unstyled 
	copy of the text. This means that these corrections will be lost
	unless we also apply the corrections to the unstyled copy that we are saving.
		So remember the unstyled copy in unstyledAcceptText, so
	that when #correctFrom:to:with: is received we can also apply
	the correction to it"
	unstyledAcceptText := styler unstyledTextFrom: textMorph asText.
	[^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: unstyledAcceptText with: self]
			ifFalse: [model perform: setTextSelector with: unstyledAcceptText]]
	] ensure:[unstyledAcceptText := nil]! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/17/2009 23:49'!
correctFrom: start to: stop with: aString
	"see the comment in #acceptTextInModel "
	unstyledAcceptText ifNotNil:[unstyledAcceptText replaceFrom: start to: stop with: aString ].
	^ super correctFrom: start to: stop with: aString! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 21:21'!
getColorSelector
	^getColorSelector! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 21:21'!
getColorSelector: aSymbol
	getColorSelector := aSymbol.
	self update: getColorSelector.! !

!PluggableTextMorphPlus methodsFor: 'menu' stamp: 'cwp 11/20/2011 23:15'!
getMenu: shiftKeyState
	"Answer the menu for this text view. We override the superclass implementation to
	so we can give the selection interval to the model."
	
	| menu aMenu |
	getMenuSelector == nil ifTrue: [^ nil].
	getMenuSelector numArgs < 3 ifTrue: [^ super getMenu: shiftKeyState].
	menu := MenuMorph new defaultTarget: model.
	getMenuSelector numArgs = 3 ifTrue:
		[aMenu := model 
			perform: getMenuSelector 
			with: menu 
			with: shiftKeyState 
			with: self selectionInterval.
		getMenuTitleSelector ifNotNil: 
			[aMenu addTitle: (model perform: getMenuTitleSelector)].
		^ aMenu].
	^ self error: 'The getMenuSelector must be a 1- or 2 or 3-keyword symbol'! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/17/2009 23:50'!
hasUnacceptedEdits: aBoolean
	"re-implemented to re-style the text iff aBoolean is true"
	 
	super hasUnacceptedEdits: aBoolean.
	(aBoolean and: [self okToStyle])
		ifTrue: [ styler styleInBackgroundProcess: textMorph contents]! !

!PluggableTextMorphPlus methodsFor: 'testing' stamp: 'ar 8/17/2009 23:53'!
okToStyle
	styler ifNil:[^false].
	(model respondsTo: #aboutToStyle: ) ifFalse:[^true].
	^model aboutToStyle: styler
! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/21/2009 21:58'!
setText: aText
	
	self okToStyle ifFalse:[^super setText: aText].
	super setText: (styler format: aText asText).
	aText size < 4096
		ifTrue:[styler style: textMorph contents]
		ifFalse:[styler styleInBackgroundProcess:  textMorph contents]! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 8/17/2009 23:51'!
styler
	"The styler responsible for highlighting text in the receiver"
	^styler! !

!PluggableTextMorphPlus methodsFor: 'accessing' stamp: 'ar 8/17/2009 23:50'!
styler: anObject
	"The styler responsible for highlighting text in the receiver"
	styler := anObject! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/17/2009 23:52'!
stylerStyled: styledCopyOfText
	"Sent after the styler completed styling the underlying text"
	textMorph contents runs: styledCopyOfText runs .
	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."     "caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	textMorph updateFromParagraph.
	selectionInterval 
		ifNotNil:[
			textMorph editor
				selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				storeSelectionInParagraph;
				setEmphasisHere].
	textMorph editor blinkParen.
	self scrollSelectionIntoView! !

!PluggableTextMorphPlus methodsFor: 'styling' stamp: 'ar 8/17/2009 23:52'!
stylerStyledInBackground: styledCopyOfText 
	"Sent after the styler completed styling of the text"

	"It is possible that the text string	has changed since the styling began. Disregard the styles if styledCopyOfText's string differs with the current textMorph contents string"
	textMorph contents string = styledCopyOfText string
		ifTrue: [self stylerStyled: styledCopyOfText]! !

!PluggableTextMorphPlus methodsFor: 'updating' stamp: 'ar 2/11/2005 21:22'!
update: what
	what ifNil:[^self].
	what == getColorSelector ifTrue:[self color: (model perform: getColorSelector)].
	^super update: what! !

!PluggableTextMorphPlus methodsFor: 'initialize' stamp: 'ar 8/18/2009 00:07'!
useDefaultStyler
	"This should be changed to a proper registry but as long as there is only shout this will do"
	Smalltalk at: #SHTextStylerST80 ifPresent:[:stylerClass|
		self styler: (stylerClass new view: self).
	].! !

ToolBuilderTests subclass: #MorphicToolBuilderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!MorphicToolBuilderTests commentStamp: 'ar 2/11/2005 15:02' prior: 0!
Tests for the Morphic tool builder.!

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 2/11/2005 19:26'!
acceptWidgetText
	widget hasUnacceptedEdits: true.
	widget accept.! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 6/21/2005 10:35'!
buttonWidgetEnabled
	"Answer whether the current widget (a button) is currently enabled"
	^widget enabled! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 2/11/2005 19:22'!
changeListWidget
	widget changeModelSelection: widget getCurrentSelectionIndex + 1.! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 12/15/2009 15:08'!
expectedButtonSideEffects
	^#(getColor getState getEnabled)! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 2/11/2005 19:15'!
fireButtonWidget
	widget performAction.! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ul 12/12/2009 14:09'!
fireMenuItemWidget
	(widget itemWithWording: 'Menu Item')
		ifNotNil: [:item | item doButtonAction]! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 2/11/2005 14:46'!
setUp
	super setUp.
	builder := MorphicToolBuilder new.! !

!MorphicToolBuilderTests methodsFor: 'tests-window' stamp: 'ar 2/13/2005 13:52'!
testWindowDynamicLabel
	self makeWindow.
	self assert: (widget label = 'TestLabel').! !

!MorphicToolBuilderTests methodsFor: 'tests-window' stamp: 'ar 2/13/2005 13:52'!
testWindowStaticLabel
	| spec |
	spec := builder pluggableWindowSpec new.
	spec model: self.
	spec children: #().
	spec label: 'TestLabel'.
	widget := builder build: spec.
	self assert: (widget label = 'TestLabel').! !

!MorphicToolBuilderTests methodsFor: 'support' stamp: 'ar 2/11/2005 21:43'!
widgetColor
	"Answer color from widget"
	^widget color! !

PluggableButtonMorph subclass: #PluggableButtonMorphPlus
	instanceVariableNames: 'enabled action getColorSelector getEnabledSelector updateMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableButtonMorphPlus commentStamp: 'ar 2/11/2005 21:53' prior: 0!
An extended version of PluggableButtonMorph supporting enablement, color and block/message actions.!

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 20:53'!
action
	^action! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 20:55'!
action: anAction	
	action := nil.
	anAction isSymbol ifTrue:[^super action: anAction].
	action := anAction.! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'dc 1/9/2008 18:17'!
enabled
	^ enabled ifNil: [enabled := true]! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'bf 5/27/2005 19:42'!
enabled: aBool
	enabled := aBool.
	enabled 
		ifFalse:[self color: Color gray]
		ifTrue:[self getModelState
			ifTrue: [self color: onColor]
			ifFalse: [self color: offColor]]! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 21:36'!
getColorSelector
	^getColorSelector! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 21:36'!
getColorSelector: aSymbol
	getColorSelector := aSymbol.
	self update: getColorSelector.! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 2/11/2005 19:51'!
getEnabledSelector
	^getEnabledSelector! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'ar 6/21/2005 11:01'!
getEnabledSelector: aSymbol
	getEnabledSelector := aSymbol.
	self update: aSymbol.! !

!PluggableButtonMorphPlus methodsFor: 'initialize-release' stamp: 'ar 8/7/2009 21:32'!
initialize
	super initialize.
	enabled := true.
	onColor := Color veryLightGray.
	offColor := Color white! !

!PluggableButtonMorphPlus methodsFor: 'action' stamp: 'ar 2/11/2005 19:52'!
mouseDown: evt
	enabled ifFalse:[^self].
	^super mouseDown: evt! !

!PluggableButtonMorphPlus methodsFor: 'action' stamp: 'ar 2/11/2005 19:52'!
mouseMove: evt
	enabled ifFalse:[^self].
	^super mouseMove: evt! !

!PluggableButtonMorphPlus methodsFor: 'action' stamp: 'ar 2/11/2005 19:53'!
mouseUp: evt
	enabled ifFalse:[^self].
	^super mouseUp: evt! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'stephaneducasse 2/3/2006 22:35'!
onColor: colorWhenOn offColor: colorWhenOff
	"Set the fill colors to be used when this button is on/off."

	onColor := colorWhenOn.
	offColor := colorWhenOff.
	self update: getStateSelector.! !

!PluggableButtonMorphPlus methodsFor: 'action' stamp: 'ar 2/11/2005 20:54'!
performAction
	enabled ifFalse:[^self].
	action ifNotNil:[^action value].
	^super performAction! !

!PluggableButtonMorphPlus methodsFor: 'updating' stamp: 'dtl 9/24/2011 11:21'!
update: what
	what ifNil:[^self].
	what == getLabelSelector ifTrue: [
		self label: (model perform: getLabelSelector)].
	what == getEnabledSelector ifTrue:[^self enabled: (model perform: getEnabledSelector)].

	getColorSelector ifNotNil: [ | cc |
		color = (cc := model perform: getColorSelector) ifFalse:[
			color := cc.
			self onColor: color offColor: color.
			self changed.
		].
	].
	self getModelState
			ifTrue: [self color: onColor]
			ifFalse: [self color: offColor].
	getEnabledSelector ifNotNil:[
		self enabled: (model perform: getEnabledSelector).
	].
	updateMap ifNotNil:
		[(updateMap at: what ifAbsent: [])
			ifNotNilDo: [ :newTarget | ^self update: newTarget]].
! !

!PluggableButtonMorphPlus methodsFor: 'updating' stamp: 'dtl 9/24/2011 08:54'!
updateMap
	^ updateMap ifNil: [updateMap := Dictionary new]
! !

!PluggableButtonMorphPlus methodsFor: 'updating' stamp: 'dtl 9/24/2011 08:54'!
whenChanged: notification update: target
	"On receipt of a notification, such as #contents notification from a CodeHolder,
	invoke an update as if target had been the original notification."

	self updateMap at: notification put: target! !
